#!/usr/bin/env python3

"""
Утилита конфигурирования клише и подвала чека
"""

import os
import subprocess
import sys
sys.path.append("/linuxcash/cash/tools/tools_avail")
from dialog import Dialog

def mainMenu(d):
    """
    Главное меню
    """
    return d.menu(
        "Выберите действие:",
        width=60, height=11, menu_height=4,
        choices=[
            ("cliche", "Редактировать клише"),
            ("tail", "Редактировать рекламный текст"),
            ("quit", "Выйти")
        ])

def setUseSeparateClicheAndTail():
    frinitConf = "/linuxcash/cash/conf/frinit.conf"
    tmpFrinitConf = "/tmp/frinit.conf"
    if os.path.exists(frinitConf):
        subprocess.call("cp " + frinitConf + " " + tmpFrinitConf, shell = True)
    else:
        subprocess.call("touch " + tmpFrinitConf, shell = True)

    subprocess.call("sed -i 's/^.*useSeparateClicheAndTail.*$/useSeparateClicheAndTail = true ;изменено редактором клише/' "
                    + tmpFrinitConf, shell = True)

    subprocess.call("sudo mv " + tmpFrinitConf + " " + frinitConf, shell=True)

def editFile(d, tag):
    editFileName = "/linuxcash/cash/conf/" + tag + ".txt"
    if not os.path.exists(editFileName):
        subprocess.call("sudo touch " + editFileName, shell = True)

    beforeEditTime = os.stat(editFileName).st_mtime
    subprocess.call("sudo mcedit " + editFileName, shell=True)

    if beforeEditTime < os.stat(editFileName).st_mtime:
        setUseSeparateClicheAndTail()

def main():
    """
    main function
    """
    d = Dialog()
    d.add_persistent_args(("--backtitle", "Настройка клише и рекламного текста"))
    try:
        isExit = False
        while not isExit:
            (code, tag) = mainMenu(d)
            if code == d.OK and tag != "quit":
                editFile(d, tag)
            else:
                isExit = True

    except KeyboardInterrupt:
        d.msgbox("Программа была завершена")
    subprocess.call("clear")

if __name__ == "__main__":
    os.chdir(os.path.dirname(os.path.abspath(__file__)))
    main()
